<script setup lang="ts">
  const props = withDefaults(
    defineProps<{
      videoSrc?: string;
      streamSrc?: any;
      hideVideo?: boolean;
      loading?: boolean;
      draggable?: boolean;
      name?: string;
      isMute?: boolean;
    }>(),
    {
      hideVideo: false,
      loading: false,
      draggable: false,
    },
  );

  const missingVideo = computed(() => props.hideVideo || (!props.videoSrc && !props.streamSrc));
  const videoAttrs = computed(() => {
    if (props.videoSrc) {
      return {
        src: props.videoSrc,
      };
    } else if (props.streamSrc) {
      return {
        srcObject: props.streamSrc,
      };
    } else {
      return null;
    }
  });
</script>
<template>
  <div
    class="shadow-5 relative flex aspect-[3/2] w-full items-center justify-center overflow-hidden rounded-lg border"
    v-bind="$attrs"
  >
    <slot name="loading">
      <SwLoading v-if="loading" />
    </slot>
    <template v-if="!loading">
      <slot name="videoPlaceholder">
        <div
          v-if="missingVideo"
          class="flex h-full w-full items-center justify-center bg-white"
          name="video-placeholder"
        >
          <span class="i-sw-solid:user"></span>
        </div>
      </slot>

      <slot name="video">
        <div v-if="!missingVideo" class="h-full w-full" name="video-source">
          <video
            v-if="videoSrc || streamSrc"
            class="h-full w-full object-cover"
            muted
            autoPlay
            playsInline
            v-bind="videoAttrs"
          />
        </div>
      </slot>
      <slot name="nameTag">
        <div v-if="name">
          <SwNameTag
            class="absolute bottom-1 left-1"
            :is-mute="isMute"
            :name="name"
            :fit-inside="false"
          >
            <template #icon>
              <slot name="icon"></slot>
            </template>
          </SwNameTag>
        </div>
      </slot>
    </template>
  </div>
</template>
